
package cheddar.aadl;

/*
 * Here is the list of AADL properties for Cheddar.
 * Some of those properties are specific to scheduling features of Cheddar.
 * Others are now part of the AADL standard, and are kept for legacy reasons.
 */

public class Cheddar_Properties {

	public static final String _NAME = "Cheddar_Properties";

	/* Processor properties */
	public static final String SCHEDULER_QUANTUM = "Scheduler_Quantum";
	public static final String PREEMPTIVE_SCHEDULER = "Preemptive_Scheduler";

	/* Data component properties */
	public static final String DATA_CONCURRENCY_STATE = "Data_Concurrency_State";
	public static final String CRITICAL_SECTION = "Critical_Section";

	/* Thread properties */
	public static final String FIXED_PRIORITY = "Fixed_Priority";
	public static final String IS_PREEMPTIBLE = "Is_Preemptible";
	public static final String POSIX_SCHEDULING_POLICY = "POSIX_Scheduling_Policy";
	public static final String BOUND_ON_DATA_BLOCKING_TIME = "Bound_On_Data_Blocking_Time";
	public static final String CRITICALITY = "Criticality";

	/* Properties to drive thread dispatching (including Cheddar specific dispatching rules) */
	public static final String DISPATCH_JITTER = "Dispatch_Jitter";
	public static final String DISPATCH_ABSOLUTE_TIME = "Dispatch_Absolute_Time";
	public static final String DISPATCH_OFFSET_VALUE_K = "Dispatch_Offset_Value_k";
	public static final String DISPATCH_OFFSET_TIME_K = "Dispatch_Offset_Time_k";
	public static final String DISPATCH_SEED_VALUE = "Dispatch_Seed_Value";
	public static final String DISPATCH_SEED_IS_PREDICTABLE = "Dispatch_Seed_is_Predictable";

	/* Properties for memory analysis */
	public static final String SOURCE_GLOBAL_TEXT_SIZE = "Source_Global_Text_Size";
	public static final String SOURCE_GLOBAL_STACK_SIZE = "Source_Global_Stack_Size";
	public static final String SOURCE_GLOBAL_DATA_SIZE = "Source_Global_Data_Size";

	/* Properties for user defined task or schedulers */
	public static final String SOURCE_TEXT = "Source_Text";

}

