
package cheddar.aadl;

import org.osate.aadl2.instance.ComponentInstance;

import cheddar.adl.Core_Unit;
import cheddar.adl.Objects_Type;
import cheddar.adl.Preemptives_Type;
import cheddar.adl.Schedulers_Type;
import cheddar.adl.Scheduling_Parameters;
import cheddar.osate2_plugin.Debug;

public class To_Core_Unit extends cheddar.adl.Core_Unit {


	static public Core_Unit Create_Core_Unit(cheddar.adl.System result, Cheddar_Id_Generator id,
			ComponentInstance component)
	{
		// Retrieve each property.
		// The policy followed here is to suppose
		// all properties are optional.
		// Then, each property is defined with a default value
		//
		String name = component.getFullName().toString();

		Integer quantum = Properties_With_Default_Value.getScheduler_Quantum(component);
		String source_text = Properties_With_Default_Value.getSource_Text(component);
		Schedulers_Type protocol = Properties_With_Default_Value.getSchedulingProtocol(component);
		Preemptives_Type preemptive = Preemptives_Type.Preemptive;
		if (!Properties_With_Default_Value.getPreemptive_Scheduler(component)) {
			preemptive = Preemptives_Type.Not_Preemptive;
		}

		// Instanciate Cheddar ADL entities
		//
		Scheduling_Parameters p = new Scheduling_Parameters();
		p.setPreemptiveType(preemptive);
		p.setSchedulerType(protocol);
		p.setUserDefinedSchedulerSourceFileName(source_text);
		p.setQuantum(quantum);

		Core_Unit c = new Core_Unit();
		c.setName("core_" + name);
		c.setScheduling(p);
		c.setcheddarXmlId(id.getAndIncrement());
		c.setObjectType(Objects_Type.Core_Object_Type);

		Debug.Put("add core " + c.getName());

		result.cores.add(c);
		return c;
	}

}
