package cheddar.aadl;

import java.util.ArrayList;

import org.osate.aadl2.instance.ComponentInstance;

import cheddar.adl.Core_Unit;
import cheddar.adl.Generic_Processor;
import cheddar.adl.Migrations_Type;
import cheddar.adl.Mono_Core_Processor;
import cheddar.adl.Multi_Cores_Processor;
import cheddar.adl.Objects_Type;
import cheddar.osate2_plugin.Debug;

public class To_Processor {


	static public Generic_Processor Create_MPSoC_Processor_Component(cheddar.adl.System result, Cheddar_Id_Generator id,
			ComponentInstance component) {

		ArrayList<Core_Unit> cores = new ArrayList<Core_Unit>();
		for (ComponentInstance c : component.getAllComponentInstances()) {
			switch (c.getCategory()) {
			case PROCESSOR:
				Core_Unit cu = To_Core_Unit.Create_Core_Unit(result, id, c);
				cores.add(cu);
				break;
			default:
				break;
			}
		}
		String name = component.getFullName().toString();

		// A processor, with its core unit
		Multi_Cores_Processor mcp = new Multi_Cores_Processor();
		mcp.setName(name);
		mcp.setcheddarXmlId(id.getAndIncrement());
		mcp.setObjectType(Objects_Type.Processor_Object_Type);
		mcp.setCores(cores);
		mcp.setMigrationType(Migrations_Type.No_Migration_Type);

		Debug.Put("add multicores processor " + mcp.getName());

		result.processors.add(mcp);
		return mcp;

	}


	static Boolean Is_MPSoC_Component(ComponentInstance component) {

		for (ComponentInstance c : component.getAllComponentInstances()) {
			switch (c.getCategory()) {
			case PROCESSOR:
				break;
			case BUS:
				break;
			case MEMORY:
				break;
			default:
				if (c.getName().toString().equals(component.getName().toString())) {
					break;
				} else {
					return false;
				}
			}
		}
		return true;
	}

	static public Generic_Processor Create_MonoCore_Processor(cheddar.adl.System result, Cheddar_Id_Generator id,
			Core_Unit core, ComponentInstance component) {

		String name = component.getFullName().toString();

		// A processor, with its core unit
		//
		Mono_Core_Processor mcp = new Mono_Core_Processor();
		mcp.setName(name);
		mcp.setcheddarXmlId(id.getAndIncrement());
		mcp.setObjectType(Objects_Type.Processor_Object_Type);
		mcp.setCore(core);
		mcp.setMigrationType(Migrations_Type.No_Migration_Type);

		Debug.Put("add monocore processor " + mcp.getName());

		result.processors.add(mcp);
		return mcp;
	}
}
