package cheddar.osate2_plugin;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.IProgressMonitor;
import org.osate.aadl2.instance.SystemInstance;
import org.osate.ui.handlers.AaxlReadOnlyHandlerAsJob;

public abstract class Abstract_Plugin extends AaxlReadOnlyHandlerAsJob {


	public void setSummaryReport() {
			this.summaryReport = new StringBuffer();
	}


	public void invoke(IProgressMonitor monitor, SystemInstance root) {
			actionBody(monitor, root);
	}

	// Write Cheddar Model XML file and return full path of the
	// generated file
	public String WriteCheddarXML(String content, String name) {

			String full_name;
			String directory_name;

			if (Config.Use_Default_Working_Directory) {
			directory_name = ResourcesPlugin.getWorkspace().getRoot().getLocation().toString();
		} else {
				directory_name = Config.Cheddar_Output_Folder;
			}

			directory_name = directory_name + "\\cheddar_xml\\";
			File f = new File(directory_name);
			f.mkdir();
			full_name = directory_name + name + ".xmlv3";

			try {
				BufferedWriter out = new BufferedWriter(new FileWriter(full_name));
				out.write(content);
				out.close();
			} catch (IOException e) {
				e.printStackTrace();
			}

			return new File(full_name).getAbsolutePath();
	}

}
