package cheddar.osate2_plugin;

import cheddar.config.Debug_Level;


public class Config {

	// Set the level of output of the plugin
	//
	public static final Debug_Level Debug = Debug_Level.Very_Verbose;

	// Data port connections can be mapped either by Cheddar "precendence"
	// dependency or by "time triggerred" Cheddar dependency
	// if Data_Port_To_Precedencies is true, Cheddar precedencies are generated
	// otherwise time triggerred entities are generated
	//
	public static final boolean Data_Port_To_Precedencies = true;

	//
	public static final Time_Units Exported_Properties_Units = Time_Units.MilliSecond;

	// False if Cheddar XML files must be generated in the "Cheddar_Output_Folder" folder
	// Generate files in the working directory instead
	public static final boolean Use_Default_Working_Directory = true;

	// Store folder where each generated files have to be stored (if working
	// directory is not selected)
	public static final String Cheddar_Output_Folder = "put here your prefered folder path";

	// Store full path and other argument to execute Cheddar binary
	public static final String Cheddar_Working_Folder = System.getProperty("user.home") + "/Cheddar_Bin/";
	public static final String Cheddar_Environment = "set CHEDDAR_INSTALL_PATH=" + Cheddar_Working_Folder + "&";
	public static final String Cheddar_Command = Cheddar_Working_Folder + "cheddar ";
}