package cheddar.osate2_plugin;

import org.eclipse.core.runtime.IProgressMonitor;
import org.osate.aadl2.Element;
import org.osate.aadl2.NamedElement;
import org.osate.aadl2.instance.ComponentInstance;
import org.osate.aadl2.instance.SystemInstance;
import org.osate.ui.dialogs.Dialog;

import cheddar.aadl.To_System;
import cheddar.core.XML_Pretty_Printer;

public class XML_Cheddar_Printer extends Abstract_Plugin {

	@Override
	public String getMarkerType() {
		return "cheddar.osate2_plugin.XML_Cheddar_Printer";
	}

	@Override
	protected String getActionName() {
		return "Instanciate Cheddar V3.x model";
	}

	@Override
	public boolean initializeAction(NamedElement obj) {
		setCSVLog("Instanciate Cheddar V3.x model", obj);
		return true;
	}


	@Override
	public final void doAaxlAction(final IProgressMonitor monitor, final Element obj) {

		if (!(obj instanceof ComponentInstance)) {
			Dialog.showError("Error", "The selected file is not at the right format");
			monitor.done();
			return;
		}

		SystemInstance si = ((ComponentInstance) obj).getSystemInstance();

		// Produce Cheddar model
		String response;
		response = new To_System().parse(si);
		response = XML_Pretty_Printer.Pretty_Print(response);

		// Save Cheddar model in output file
		String file_info = WriteCheddarXML(response, si.getName());
		String msg = "Cheddar XML V3 model generated in the file :  " + file_info;
		Debug.Put(msg);
		Dialog.showInfo("Instanciate Cheddar V3.x model", msg);
	}




}